#include<iostream>
#include<cmath>
using namespace std;

int main(){
	int N,M;
	//cout<<"unesi N i M "<<endl;
	cin>>N>>M;
	int brojNavijaca[N][M];
	int rezultati[N][M];
	//cout<<"unesi br ljudi na svakom polju "<<endl;
	for(int i=0;i<N;i++){
		for(int j=0;j<M;j++){
			cin>>brojNavijaca[i][j];
		}
	}
	for(int i=0;i<N;i++){
		for(int j=0;j<M;j++){
            rezultati[i][j]=0;
		}
	}
    int Q;
	//cout<<"unesi br scenarija Q "<<endl;
	cin>>Q;
    int Qrezultati[Q];
	for(int q=0;q<Q;q++){
        //cout<<"unesi kordinate blokiranih polja"<<endl;
        int qx,qy;
        cin>>qx>>qy;
        int poz1=-1,poz2=-1;
        for(int i=0;i<N;i++){
            for(int j=0;j<M;j++){
                poz1=-1,poz2=-1;
                if(0==i && 0==j){
                    rezultati[0][0]=brojNavijaca[0][0];
                    continue;
                }
                if(i!=0 && !(i-1==qx && j==qy)){
                    poz1=rezultati[i-1][j];
                }
                if(j!=0 && !(j-1==qy && i==qx)){
                    poz2=rezultati[i][j-1];
                }
                if(poz1<0){
                    rezultati[i][j]=brojNavijaca[i][j]+poz2;
                    continue;
                }
                if(poz2<0){
                    rezultati[i][j]=brojNavijaca[i][j]+poz1;
                    continue;
                }
                if(poz1<poz2){
                    rezultati[i][j]=brojNavijaca[i][j]+poz1;
                }
                else{
                    rezultati[i][j]=brojNavijaca[i][j]+poz2;
                }
            }
        }
        Qrezultati[q]=rezultati[N-1][M-1];
        for(int i=0;i<N;i++){
            for(int j=0;j<M;j++){
               // cout<<rezultati[i][j]<<" ";
            }
        }
    }
    for(int q=0;q<Q;q++){
        cout<<Qrezultati[q]<<endl;
    }

}